''  *** COMPILED WITH PropBasic VERSION 00.01.02  Jul 20, 2010 ***
                                                             '' ======================================================================
                                                             ''
                                                             ''   File...... PropBasicTV_Text_Demo.pbas
                                                             ''   Purpose... Recreates Parallax TV_Text Demo in PropBASIC
                                                             ''   Author.... Coley
                                                             ''   E-mail.... coley@propgfx.co.uk
                                                             ''   Started... 29 AUG 2010
                                                             ''   Updated... 30 AUG 2010
                                                             ''
                                                             '' ======================================================================

                                                             '' ----------------------------------------------------------------------
                                                             '' Conditional Compilation Symbols
                                                             '' ----------------------------------------------------------------------
                                                             ''{$CODE}
                                                             '' ----------------------------------------------------------------------
                                                             '' Device Settings
                                                             '' ----------------------------------------------------------------------



CON                                                          'DEVICE          P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq = 5000000                                         'XIN             5_000_000


                                                             'LOAD "TV_TEXT_LIB.pbas"         ' Load in the TV_Text routine
                                                             '' ======================================================================
                                                             '' TV_Text Output Library for PropBASIC
                                                             '' -- by Coley
                                                             '' -- 30 August 2010
                                                             '' -- requires PropBASIC 0.98 or later
                                                             '' ======================================================================
' Start_TV_Text   SUB     0           ' Set up the screen and colours 'Start_TV_Text   SUB     0           ' Set up the screen and colours

' Print		SUB     1           ' Print a character             'Print		SUB     1           ' Print a character

' PrintStr	SUB     1           ' Print a string of character 'PrintStr	SUB     1           ' Print a string of character

' Out		SUB     1           ' Print control characters        'Out		SUB     1           ' Print control characters

' NewLine		SUB     0           ' Carriage return and linefeed 'NewLine		SUB     0           ' Carriage return and linefeed

' HEX             SUB     1,2         ' Print a value as Hexadecimal 'HEX             SUB     1,2         ' Print a value as Hexadecimal

' BIN             SUB     1,2         ' Print a value as Binary 'BIN             SUB     1,2         ' Print a value as Binary

' DECX            SUB     1           ' Print a value as Decimal 'DECX            SUB     1           ' Print a value as Decimal


                                                             '' ----------------------------------------------------------------------


                                                             'LOAD "PropBasicTV.lib"          ' Load in the TV Driver
                                                             '' ======================================================================
                                                             ''
                                                             ''   File...... 
                                                             ''   Purpose... 
                                                             ''   Author.... 
                                                             ''   E-mail....
                                                             ''   Started... DD MMM YYYY
                                                             ''   Updated... DD MMM YYYY
                                                             ''
                                                             '' ======================================================================


                                                             '' ----------------------------------------------------------------------
                                                             '' Program Description
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' Conditional Compilation Symbols
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' Constants
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' I/O Pins
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' Shared (hub) Variables (Byte, Word, Long)
                                                             '' ----------------------------------------------------------------------

                                                             ''  repeat i from 0 to 7
                                                             ''    fore := byte[colorptr][i << 1]
                                                             ''    back := byte[colorptr][i << 1 + 1]
                                                             ''    colors[i << 1]     := fore << 24 + back << 16 + fore << 8 + back
                                                             ''    colors[i << 1 + 1] := fore << 24 + fore << 16 + back << 8 + back

                                                             '' ----------------------------------------------------------------------
                                                             '' Shared (hub) Data (DATA, WDATA, LDATA, FILE)
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' TASK Definitions
                                                             '' ----------------------------------------------------------------------

OBJ TV_PARALLAX: "TV_PARALLAX.spin"                          'TV_PARALLAX TASK AUTO


                                                             '' ----------------------------------------------------------------------
                                                             '' Cog Variables (Long only)
                                                             '' ----------------------------------------------------------------------

                                                             '' Define variables
' TV_curX    VAR LONG = 0                                    'TV_curX    VAR LONG = 0

' TV_curY    VAR LONG = 0                                    'TV_curY    VAR LONG = 0


                                                             '' Define Subroutines
' TV_Print     SUB 1                                         'TV_Print     SUB 1

' TV_PrintAt   SUB 3                                         'TV_PrintAt   SUB 3

' TV_Char      SUB 1                                         'TV_Char      SUB 1


                                                             '' ----------------------------------------------------------------------
                                                             '' SUB/FUNC Definitions
                                                             '' ----------------------------------------------------------------------




                                                             '' ----------------------------------------------------------------------
                                                             '' Constants
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' I/O Pins
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' Shared (hub) Variables (Byte, Word, Long)
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' Shared (hub) Data (DATA, WDATA, LDATA, FILE)
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' TASK Definitions
                                                             '' ----------------------------------------------------------------------

                                                             '' ----------------------------------------------------------------------
                                                             '' Cog Variables (Long only)
                                                             '' ----------------------------------------------------------------------

' TempVar1	VAR LONG                                          'TempVar1	VAR LONG

' TempVar2	VAR LONG                                          'TempVar2	VAR LONG

' TempVar3	VAR LONG                                          'TempVar3	VAR LONG


                                                             '' ----------------------------------------------------------------------
                                                             '' SUB/FUNC Definitions
                                                             '' ----------------------------------------------------------------------

                                                             '' ======================================================================
PUB __Program                                                'PROGRAM Start
  TV_PARALLAX_COG:=TV_PARALLAX.Init(@__DATASTART)           
  CogNew(TV_PARALLAX_COG >> 2, @__DATASTART)                
  CogInit(0, @__Init, @__DATASTART)                         
                                                            
DAT                                                         
                  org           0                           
__Init                                                      
__RAM                                                       
                  mov           dira,__InitDirA             
                  mov           outa,__InitOutA             
                  jmp           #Start                      

                                                             '' ======================================================================

Start                                                        'Start:


                  call          #Start_TV_Text               '  Start_TV_Text


Main                                                         'Main:


                  mov           __param1,#$00                '  OUT $00                                               ' Clear Screen
                  call          #OUT                        

                  mov           __param1,#$0C                '  OUT $0C                                               ' Set Colour
                  call          #OUT                        

                  mov           __param1,#$00                '  OUT $00                                               ' Palette 0
                  call          #OUT                        

                                                             '  'OUT $0D                                               ' Carriage Return
                  mov           __param1,#InLineStr1_ofs     '  PRINTSTR "   TV Text Demo...  PropBASIC Version"
                  add           __param1,par                
                  call          #PRINTSTR                   

                  mov           __param1,#$0D                '  OUT $0D                                               ' Carriage Return
                  call          #OUT                        

                  mov           __param1,#$0D                '  OUT $0D                                               ' Carriage Return
                  call          #OUT                        

                  mov           __param1,#$0c                '  OUT $0c                                               ' Set Colour
                  call          #OUT                        

                  mov           __param1,#$05                '  OUT $05                                               ' Palette 5
                  call          #OUT                        

                  mov           __param1,#InLineStr2_ofs     '  PRINTSTR " OBJ and VAR require only 2.8KB "
                  add           __param1,par                
                  call          #PRINTSTR                   

                  mov           __param1,#$0C                '  OUT $0C                                               ' Set Colour
                  call          #OUT                        

                  mov           __param1,#$01                '  OUT $01                                               ' Palette 1
                  call          #OUT                        

                  mov           TempVar1,#1                  '  FOR TempVar1 = 1 TO 14                                ' Print some
__FOR_TempVar1_1                                            

                  mov           __param1,#" "                '    print " "                                           ' Spaces
                  call          #print                      

                  adds          TempVar1,#1                  '  NEXT TempVar1                                         '
                  cmps          TempVar1,#14 WZ, WC         
    IF_BE         jmp           #__FOR_TempVar1_1           
__NEXT_TempVar1_1                                           

                  mov           TempVar1,#$0e                '  FOR TempVar1 = $0e TO $ff                             ' Print some
__FOR_TempVar1_2                                            

                  mov           __param1,TempVar1            '    PRINT TempVar1                                      ' more characters
                  call          #PRINT                      

                  adds          TempVar1,#1                  '  NEXT TempVar1                                         '
                  cmps          TempVar1,#$ff WZ, WC        
    IF_BE         jmp           #__FOR_TempVar1_2           
__NEXT_TempVar1_2                                           

                  mov           __param1,#$0C                '  OUT $0C                                               ' Set Colour
                  call          #OUT                        

                  mov           __param1,#$06                '  OUT $06                                               ' Palette 6
                  call          #OUT                        

                  mov           __param1,#InLineStr3_ofs     '  PRINTSTR "     Uses internal ROM font     "
                  add           __param1,par                
                  call          #PRINTSTR                   

                  mov           __param1,#$0C                '  OUT $0C                                               ' Set Colour
                  call          #OUT                        

                  mov           __param1,#$02                '  OUT $02                                               ' Palette 2
                  call          #OUT                        

                  mov           TempVar1,#0                  '  TempVar1 = 0

__DO_1                                                       '  DO

                  mov           __param1,#$0A                '    OUT $0A                                             ' Set column position
                  call          #OUT                        

                  mov           __param1,#$04                '    OUT $04                                             ' to 4
                  call          #OUT                        

                  mov           __param1,#$0B                '    OUT $0B                                             ' Set row position
                  call          #OUT                        

                  mov           __param1,#$0B                '    OUT $0B                                             ' to 11
                  call          #OUT                        

                  mov           __param1,TempVar1            '    DECX TempVar1                                       ' Output variable in decimal
                  call          #DECX                       

                  mov           __param1,#$0A                '    OUT $0A                                             ' Set column position
                  call          #OUT                        

                  mov           __param1,#$1C                '    OUT $1C                                             ' to 28
                  call          #OUT                        

                  mov           __param1,TempVar1            '    HEX TempVar1,8                                      ' Output variable in 8 digit hex
                  mov           __param2,#8                 
                  mov           __paramcnt,#2               
                  call          #HEX                        

                  mov           __param1,#$0A                '    OUT $0A                                             ' Set column position
                  call          #OUT                        

                  mov           __param1,#$04                '    OUT $04                                             ' to 4
                  call          #OUT                        

                  mov           __param1,#$0B                '    OUT $0B                                             ' Set row position
                  call          #OUT                        

                  mov           __param1,#$0C                '    OUT $0C                                             ' to 12
                  call          #OUT                        

                  mov           __param1,TempVar1            '    BIN TempVar1,32                                     ' Output variable in 32 digit binary
                  mov           __param2,#32                
                  mov           __paramcnt,#2               
                  call          #BIN                        

                  adds          TempVar1,#1                  '    INC TempVar1                                        ' Increase variable

                  jmp           #__DO_1                      '  LOOP
__LOOP_1                                                    


                  mov           __temp1,#0                   'END
                  waitpne       __temp1,__temp1             




                                                             ''{$CODE}
                                                             '' ----------------------------------------------------------------------
' cols            CON 40                                     'cols            CON 40

' rows            CON 13                                     'rows            CON 13



' __TempVar1	VAR LONG                                        '__TempVar1	VAR LONG

' __TempVar2	VAR LONG                                        '__TempVar2	VAR LONG

' __TempVar3	VAR LONG                                        '__TempVar3	VAR LONG

' __TempVar4	VAR LONG                                        '__TempVar4	VAR LONG

' __TempVar5	VAR LONG                                        '__TempVar5	VAR LONG

' __TempVar6	VAR LONG                                        '__TempVar6	VAR LONG

' __TempVar7      VAR LONG                                   '__TempVar7      VAR LONG


' Colour		VAR LONG = 0                                       'Colour		VAR LONG = 0

' Col		VAR LONG = 0                                          'Col		VAR LONG = 0

' Row		VAR LONG = 0                                          'Row		VAR LONG = 0

' Flag            VAR LONG = 0                               'Flag            VAR LONG = 0


' LastRow		VAR LONG                                          'LastRow		VAR LONG

' ScrOffset	VAR LONG                                         'ScrOffset	VAR LONG

' ScrPointer      VAR LONG                                   'ScrPointer      VAR LONG

' ScreenRAM       VAR LONG                                   'ScreenRAM       VAR LONG

' ScreenColours   VAR LONG                                   'ScreenColours   VAR LONG

' srcptr          VAR LONG                                   'srcptr          VAR LONG

' dstptr          VAR LONG                                   'dstptr          VAR LONG

' Fore            VAR LONG                                   'Fore            VAR LONG

' Back            VAR LONG                                   'Back            VAR LONG


'tv_params       LDATA  0            'status                 'tv_params       LDATA  0            'status

'                LDATA  1            'enable                 '                LDATA  1            'enable

'                LDATA  %001_0101    'pins                   '                LDATA  %001_0101    'pins

'                LDATA  %10011       'mode                   '                LDATA  %10011       'mode

'scrptr          LDATA 0'scrbuf      'screen                 'scrptr          LDATA 0'scrbuf      'screen

'colptr          LDATA 0'colours     'colors                 'colptr          LDATA 0'colours     'colors

'                LDATA cols          'hc                     '                LDATA cols          'hc

'                LDATA rows          'vc                     '                LDATA rows          'vc

'                LDATA 5             'hx                     '                LDATA 5             'hx

'                LDATA 1             'vx                     '                LDATA 1             'vx

'                LDATA 0             'ho                     '                LDATA 0             'ho

'                LDATA 0             'vo                     '                LDATA 0             'vo

'                LDATA 0             'broadcast              '                LDATA 0             'broadcast

'                LDATA 0             'auralcog               '                LDATA 0             'auralcog



                                                             '                '     Fore   Back
                                                             '                '     color  color
'palette         DATA  $07,   $0A                            'palette         DATA  $07,   $0A    '0    white / dark blue

'                DATA  $07,   $BB                            '                DATA  $07,   $BB    '1    white / red

'                DATA  $9E,   $9B                            '                DATA  $9E,   $9B    '2   yellow / brown

'                DATA  $04,   $07                            '                DATA  $04,   $07    '3     grey / white

'                DATA  $3D,   $3B                            '                DATA  $3D,   $3B    '4     cyan / dark cyan

'                DATA  $6B,   $6E                            '                DATA  $6B,   $6E    '5    green / gray-green

'                DATA  $BB,   $CE                            '                DATA  $BB,   $CE    '6      red / pink

'                DATA  $3C,   $0A                            '                DATA  $3C,   $0A    '7     cyan / blue


' HUB WORD scrbuf(520)                                       'scrbuf    HUB WORD (520)=$220

' HUB LONG colours(16)                                       'colours   HUB LONG (16)





                                                             ''========================================================================================
                                                             ''{$IFUSED Start_TV_Text}
Start_TV_Text                                                'SUB Start_TV_Text


                  mov           ScreenRAM,#scrbuf_ofs        '  ScreenRAM = GETADDR scrbuf
                  add           ScreenRAM,par               

                  mov           dstptr,#SCRPTR_ofs           '  dstptr = GETADDR scrptr
                  add           dstptr,par                  

                  wrlong        ScreenRAM,dstptr             '  wrlong dstptr,ScreenRAM


                  mov           ScreenColours,__colours_ofs  '  ScreenColours = GETADDR colours
                  add           ScreenColours,par           

                  mov           dstptr,#COLPTR_ofs           '  dstptr = GETADDR colptr
                  add           dstptr,par                  

                  wrlong        ScreenColours,dstptr         '  wrlong dstptr,ScreenColours


                  mov           TempVar1,#PALETTE_ofs        '  TempVar1 = GETADDR palette
                  add           TempVar1,par                

                  mov           TempVar2,ScreenColours       '  TempVar2 = ScreenColours


                  mov           TempVar3,#0                  '  For TempVar3 = 0 to 7                 ' Set up the colour palette
__FOR_TempVar3_3                                            

                  rdbyte        Fore,TempVar1                '    RDBYTE TempVar1,Fore

                  adds          TempVar1,#1                  '    INC TempVar1

                  rdbyte        Back,TempVar1                '    RDBYTE TempVar1,Back

                  adds          TempVar1,#1                  '    INC TempVar1

                  wrbyte        Back,ScreenColours           '    WRBYTE ScreenColours,Back

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Fore,ScreenColours           '    WRBYTE ScreenColours,Fore

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Back,ScreenColours           '    WRBYTE ScreenColours,Back

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Fore,ScreenColours           '    WRBYTE ScreenColours,Fore

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Back,ScreenColours           '    WRBYTE ScreenColours,Back

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Back,ScreenColours           '    WRBYTE ScreenColours,Back

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Fore,ScreenColours           '    WRBYTE ScreenColours,Fore

                  adds          ScreenColours,#1             '    INC ScreenColours

                  wrbyte        Fore,ScreenColours           '    WRBYTE ScreenColours,Fore

                  adds          ScreenColours,#1             '    INC ScreenColours

                  adds          TempVar3,#1                  '  Next
                  cmps          TempVar3,#7 WZ, WC          
    IF_BE         jmp           #__FOR_TempVar3_3           
__NEXT_TempVar3_3                                           

Start_TV_Text_ret                                            'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}
                                                             ''========================================================================================
                                                             ''{$IFUSED Print}
Print                                                        'SUB Print				' Char (__param1)


'   Char Var __param1			'                                    '  Char Var __param1			'

                  mov           __temp1,Row                  '  ScrOffset = row * cols                '
                  mov           __temp2,#cols               
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0001                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0001            
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           ScrOffset,__temp1           

                                                             '  ScrOffset = ScrOffset + col		'
                  adds          ScrOffset,Col               

                  shl           ScrOffset,#1                 '  ScrOffset = ScrOffset * 2		'

                                                             '  ScrOffset = ScrOffset + ScreenRAM	'
                  adds          ScrOffset,ScreenRAM         

                  mov           __TempVar2,Colour            '  __TempVar2 = colour << 1		'
                  shl           __TempVar2,#1               

                  mov           __TempVar3,Char              '  __TempVar3 = Char & 1			'
                  and           __TempVar3,#1               

                                                             '  __TempVar2 = __TempVar2 + __TempVar3	'
                  adds          __TempVar2,__TempVar3       

                                                             '  __TempVar2 = __TempVar2 << 10		' Work OUT word value for screen ram location
                  shl           __TempVar2,#10              

                                                             '  __TempVar2 = __TempVar2 + $200	'
                  adds          __TempVar2,_hex200          

                  mov           __TempVar3,Char              '  __TempVar3 = Char & $FE		'
                  and           __TempVar3,#$FE             

                                                             '  __TempVar2 = __TempVar2 + __TempVar3	'
                  adds          __TempVar2,__TempVar3       


                  wrword        __TempVar2,ScrOffset         '  WRWord ScrOffset, __TempVar2		' Write word to screen ram location


                  adds          Col,#1                       '  inc col				' Increase __TempVar screen ram location by 1 word (2 bytes)

                  cmps          Col,#cols WZ, WC             '  if col = cols then
    IF_NE         jmp           #__ELSE_1                   
__IF_1                                                      

                  call          #Newline                     '    Newline

__ELSE_1                                                     '  endif
__ENDIF_1                                                   


Print_ret                                                    'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}

                                                             ''========================================================================================
                                                             ''DECX Subroutine extracted and adapted from tx_format_lib.pbas by Jon McPhelan
                                                             ''========================================================================================
                                                             ''{$IFUSED DECX}
DECX                                                         'SUB DECX

'   dcDigit       VAR     __param1                           '  dcDigit       VAR     __param1

'   dcVal         VAR     __param2                           '  dcVal         VAR     __param2

'   dcDiv         VAR     __param3                           '  dcDiv         VAR     __param3

'   dcNegX        VAR     __param4                           '  dcNegX        VAR     __param4

'   dcPrint       VAR     Long                               '  dcPrint       VAR     Long


                  mov           dcVal,__param1               '  dcVal = __param1                              ' capture value

                  mov           dcNegX,#0                    '  dcNegX = 0                                    ' assume not NEGX


                  cmps          dcVal,#0 WZ, WC              '  IF dcVal = 0 THEN                             ' if zero
    IF_NE         jmp           #__ELSE_2                   
__IF_2                                                      

                  mov           __param1,#"0"                '    PRINT "0"                                   '   we're done
                  call          #PRINT                      

                  jmp           #__ENDIF_2                   '  ELSE
__ELSE_2                                                    

                  cmps          dcVal,#0 WZ, WC              '    IF dcVal < 0 THEN                           ' negative?
    IF_AE         jmp           #__ELSE_3                   

                  mov           __param1,#"-"                '      PRINT "-"                                 '   print sign
                  call          #PRINT                      

                  cmps          dcVal,_hex80000000 WZ, WC    '      IF dcVal = $8000_0000 THEN                '   negx?
    IF_NE         jmp           #__ELSE_4                   

                  adds          dcVal,#1                     '        INC dcVal                               '   yes, fix

                  mov           dcNegX,#1                    '        dcNegX = 1                              '   and set flag

__ELSE_4                                                     '      ENDIF
__ENDIF_4                                                   

                  abs           dcVal,dcVal                  '      dcVal = ABS dcVal                         '   make positive

__ELSE_3                                                     '    ENDIF
__ENDIF_3                                                   

                  mov           dcDiv,_1000000000            '    dcDiv = 1_000_000_000                       ' set divisor

                  mov           dcPrint,#0                   '    dcPrint = 0                                 ' print flag off

__DO_2                                                       '    DO WHILE dcDiv > 0                          ' while digits left
                  cmps          dcDiv,#0 WZ, WC             
    IF_BE         jmp           #__LOOP_2                   

                  mov           dcDigit,#0                   '      dcDigit = 0                               ' assume digit value

__DO_3                                                       '      DO WHILE dcVal >= dcDiv                   ' extract digit
                  cmps          dcVal,dcDiv WZ, WC          
    IF_B          jmp           #__LOOP_3                   

                                                             '        dcVal = dcVal - dcDiv
                  subs          dcVal,dcDiv                 

                  adds          dcDigit,#1                   '        INC dcDigit

                  jmp           #__DO_3                      '      LOOP
__LOOP_3                                                    

                                                             '      dcPrint = dcPrint + dcDigit               ' update lead-0 flag
                  adds          dcPrint,dcDigit             

                  cmps          dcPrint,#0 WZ, WC            '      IF dcPrint > 0 THEN                       ' past leading zeroes?
    IF_BE         jmp           #__ELSE_5                   

                  cmps          dcDiv,#1 WZ, WC              '        IF dcDiv = 1 THEN                       ' on 1s digit?
    IF_NE         jmp           #__ELSE_6                   

                                                             '          dcDigit = dcDigit + dcNegX            '   yes, adjust for NEGX
                  adds          dcDigit,dcNegX              

__ELSE_6                                                     '        ENDIF
__ENDIF_6                                                   

                                                             '        dcDigit = dcDigit + "0"                 '   convert to ASCII
                  adds          dcDigit,#"0"                

                  mov           __param1,dcDigit             '        PRINT dcDigit                           '   and print
                  call          #PRINT                      

__ELSE_5                                                     '      ENDIF
__ENDIF_5                                                   

                  mov           __temp1,dcDiv                '      dcDiv = dcDiv / 10                        ' update divisor
                  mov           __temp2,#10                 
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #__L0002                    
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0003                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #__L0003                    
                  rcr           __temp2,#1                  
__L0004                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#__L0004            
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0002                                                     
                  mov           dcDiv,__temp4               

                  jmp           #__DO_2                      '    LOOP
__LOOP_2                                                    

__ENDIF_2                                                    '  ENDIF

DECX_ret                                                     'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}

                                                             ''========================================================================================
                                                             ''Hex Subroutine extracted and adapted from tx_format_lib.pbas by Jon McPhelan
                                                             ''========================================================================================
                                                             ''{$IFUSED HEX}
HEX                                                          'SUB HEX


'   hxDigit       VAR     __param1                ' used by TX_BYTE '  hxDigit       VAR     __param1                ' used by TX_BYTE

'   hxVal         VAR     __param2                           '  hxVal         VAR     __param2

'   hxCount       VAR     __param3                           '  hxCount       VAR     __param3


                  cmps          __paramcnt,#1 WZ, WC         '  IF __paramcnt = 1 THEN                        ' no digits spec'd?
    IF_NE         jmp           #__ELSE_7                   
__IF_7                                                      

                  mov           __param2,#1                  '    __param2 = 1                                '   use default

                  jmp           #__ENDIF_7                   '  ELSE
__ELSE_7                                                    

                                                             '    __param2 = __param2 MIN 1                   ' keep in legal limits
                  mins          __param2,#1                 

                                                             '    __param2 = __param2 MAX 8
                  maxs          __param2,#8                 

__ENDIF_7                                                    '  ENDIF


                  mov           hxCount,__param2             '  hxCount = __param2                            ' save count

                  mov           __temp1,__param2             '  __param2 = 8 - __param2                       ' adjust for <<
                  mov           __param2,#8                 
                  subs          __param2,__temp1            

                                                             '  __param2 = __param2 << 2                      ' convert to nib (x4)
                  shl           __param2,#2                 

   mov __temp1, __param1                       ' hxVal = __param1 << __param2 '  \ mov __temp1, __param1                       ' hxVal = __param1 << __param2

   shl __temp1, __param2                                     '  \ shl __temp1, __param2

   mov hxVal, __temp1                                        '  \ mov hxVal, __temp1


__DO_4                                                       '  DO WHILE hxCount > 0
                  cmps          hxCount,#0 WZ, WC           
    IF_BE         jmp           #__LOOP_4                   

   ROL hxVal, #4                             ' rotate nib to lsb '    \ ROL hxVal, #4                             ' rotate nib to lsb

                  mov           hxDigit,hxVal                '    hxDigit = hxVal & $F                        ' extract hex digit
                  and           hxDigit,#$F                 

                  cmps          hxDigit,#10 WZ, WC           '    IF hxDigit < 10 THEN                        ' convert to ASCII
    IF_AE         jmp           #__ELSE_8                   
__IF_8                                                      

                                                             '      hxDigit = hxDigit + "0"                   ' "0" - "9"
                  adds          hxDigit,#"0"                

                  jmp           #__ENDIF_8                   '    ELSE
__ELSE_8                                                    

                                                             '      hxDigit = hxDigit + 55                    ' "A" - "F"
                  adds          hxDigit,#55                 

__ENDIF_8                                                    '    ENDIF

                  mov           __param1,hxDigit             '    PRINT hxDigit
                  call          #PRINT                      

                  subs          hxCount,#1                   '    DEC hxCount

                  jmp           #__DO_4                      '  LOOP
__LOOP_4                                                    


HEX_ret                                                      'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}

                                                             ''========================================================================================
                                                             ''Bin Subroutine extracted and adapted from tx_format_lib.pbas by Jon McPhelan
                                                             ''========================================================================================
                                                             ''{$IFUSED BIN}
                                                             '' Use: BIN value, digits
                                                             '' -- prints binary string of value


BIN                                                          'SUB BIN


'   biDigit       VAR     __param1                ' used by TX_BYTE '  biDigit       VAR     __param1                ' used by TX_BYTE

'   biVal         VAR     __param2                           '  biVal         VAR     __param2

'   biCount       VAR     __param3                           '  biCount       VAR     __param3


                  cmps          __paramcnt,#1 WZ, WC         '  IF __paramcnt = 1 THEN                        ' no digits spec'd?
    IF_NE         jmp           #__ELSE_9                   
__IF_9                                                      

                  mov           __param2,#1                  '    __param2 = 1                                '   use default

                  jmp           #__ENDIF_9                   '  ELSE
__ELSE_9                                                    

                                                             '    __param2 = __param2 MIN 1                   ' keep in legal limits
                  mins          __param2,#1                 

                                                             '    __param2 = __param2 MAX 32
                  maxs          __param2,#32                

__ENDIF_9                                                    '  ENDIF


                  mov           biCount,__param2             '  biCount = __param2                            ' save count

                  mov           __temp1,__param2             '  __param2 = 32 - __param2                      ' adjust for <<
                  mov           __param2,#32                
                  subs          __param2,__temp1            

   mov __temp1, __param1                       ' biVal = __param1 << __param2 '  \ mov __temp1, __param1                       ' biVal = __param1 << __param2

   shl __temp1, __param2                                     '  \ shl __temp1, __param2

   mov biVal, __temp1                                        '  \ mov biVal, __temp1


__DO_5                                                       '  DO WHILE biCount > 0
                  cmps          biCount,#0 WZ, WC           
    IF_BE         jmp           #__LOOP_5                   

   ROL biVal, #1                             ' rotate bit to lsb '    \ ROL biVal, #1                             ' rotate bit to lsb

                  mov           biDigit,biVal                '    biDigit = biVal & %1                        ' extract binary digit
                  and           biDigit,#1                  

                                                             '    biDigit = biDigit + "0"                     ' convert to ASCII
                  adds          biDigit,#"0"                

                  mov           __param1,biDigit             '    PRINT biDigit
                  call          #PRINT                      

                  subs          biCount,#1                   '    DEC biCount

                  jmp           #__DO_5                      '  LOOP
__LOOP_5                                                    

BIN_ret                                                      'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}
                                                             ''========================================================================================
                                                             ''{$IFUSED Newline}
Newline                                                      'SUB Newline

                  mov           Col,#0                       '  col = 0

                  adds          Row,#1                       '  inc Row

                  cmps          Row,#rows WZ, WC             '  if Row = rows then
    IF_NE         jmp           #__ELSE_10                  
__IF_10                                                     

                  subs          Row,#1                       '    dec row

                  mov           ScrPointer,ScreenRAM         '   ScrPointer = ScreenRAM

                  mov           __TempVar6,#rows             '    __TempVar6 = rows - 1
                  adds          __TempVar6,_minus1          

                  mov           __temp1,__TempVar6           '    __TempVar6 = __TempVar6 * cols
                  mov           __temp2,#cols               
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0005                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0005            
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           __TempVar6,__temp1          

                  mov           __remainder,__TempVar6       '    __TempVar6 = __TempVar6 / 2
                  and           __remainder,#1              
                  sar           __TempVar6,#1               

__DO_6                                                       '    DO

                  mov           __TempVar5,#cols             '      __TempVar5 = cols * 2
                  shl           __TempVar5,#1               

                                                             '      __TempVar5 = __TempVar5 + ScrPointer
                  adds          __TempVar5,ScrPointer       

                  rdlong        __TempVar7,__TempVar5        '      RdLong __TempVar5, __TempVar7

                  wrlong        __TempVar7,ScrPointer        '      WrLong ScrPointer, __TempVar7

                  adds          ScrPointer,#4                '      INC ScrPointer,4

                  djnz          __TempVar6,#__DO_6           '    LOOP __TempVar6
__LOOP_6                                                    

                  mov           __TempVar6,#cols             '    __TempVar6 = cols

__DO_7                                                       '    DO

                  wrword        _hex220,ScrPointer           '      WrWord ScrPointer, $220

                  adds          ScrPointer,#2                '      INC ScrPointer,2

                  djnz          __TempVar6,#__DO_7           '    LOOP __TempVar6
__LOOP_7                                                    

__ELSE_10                                                    '  EndIf
__ENDIF_10                                                  

Newline_ret                                                  'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}
                                                             ''========================================================================================
                                                             ''{$IFUSED PrintStr}
PrintStr                                                     'SUB PrintStr

                  mov           __param2,__param1            '  __param2 = __param1 ' Print uses __param1

__DO_8                                                       '  DO

                  rdbyte        __param3,__param2            '    RDBYTE __param2, __param3

                  cmps          __param3,#0 WZ, WC           '    IF __param3 = 0 THEN EXIT
    IF_E          jmp           #__LOOP_8                   

                  mov           __param1,__param3            '    Print __param3
                  call          #Print                      

                  adds          __param2,#1                  '    INC __param2

                  jmp           #__DO_8                      '  LOOP
__LOOP_8                                                    

PrintStr_ret                                                 'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}
                                                             ''========================================================================================
                                                             ''{$IFUSED Out}
Out                                                          'SUB Out

'   character var __param1 ' Print uses __param1             '  character var __param1 ' Print uses __param1


                  cmps          Flag,#0 WZ, WC               '  IF Flag = 0 THEN
    IF_NE         jmp           #__ELSE_11                  
__IF_11                                                     


                  cmps          character,#$00 WZ, WC        '    IF character = $00 THEN      ' Clear Screen
    IF_NE         jmp           #__ELSE_12                  

                  mov           ScrPointer,ScreenRAM         '      ScrPointer = ScreenRAM

                  mov           __temp1,#cols                '      __TempVar6 = cols * rows
                  mov           __temp2,#rows               
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0006                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#__L0006            
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           __TempVar6,__temp1          

__DO_9                                                       '      DO

                  wrword        _hex220,ScrPointer           '        WrWord ScrPointer, $220

                  adds          ScrPointer,#2                '        INC ScrPointer,2

                  djnz          __TempVar6,#__DO_9           '      LOOP __TempVar6
__LOOP_9                                                    

                  mov           Col,#0                       '      col = 0

                  mov           Row,#0                       '      row = 0

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_12                                                    '    ENDIF
__ENDIF_12                                                  


                  cmps          character,#$01 WZ, WC        '    IF character = $01 THEN     ' Home
    IF_NE         jmp           #__ELSE_13                  

                  mov           Col,#0                       '      Col = 0                   ' Set text column to left

                  mov           Row,#0                       '      Row = 0                   ' Set text row to top

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_13                                                    '    ENDIF
__ENDIF_13                                                  


                  cmps          character,#$08 WZ, WC        '    IF character = $08 THEN     ' TAB
    IF_NE         jmp           #__ELSE_14                  

__DO_10                                                      '      DO

                  adds          Col,#1                       '      INC col                   ' Increase text column

                  mov           __TempVar6,Col               '      __TempVar6 = col & 7        ' Check for tab stop boundary (every 8 characters)
                  and           __TempVar6,#7               

                  tjnz          __TempVar6,#__DO_10          '      LOOP WHILE __TempVar6       ' Loop until we hit a tab stop

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_14                                                    '    ENDIF
__ENDIF_14                                                  


                  cmps          character,#$09 WZ, WC        '    IF character = $09 THEN     ' Backspace
    IF_NE         jmp           #__ELSE_15                  

                  cmps          Col,#0 WZ, WC                '      IF col > 0 THEN           ' Check if we can go back
    IF_BE         jmp           #__ELSE_16                  

                  subs          Col,#1                       '        Dec col                 ' Decrease text column position

__ELSE_16                                                    '      ENDIF
__ENDIF_16                                                  

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_15                                                    '    ENDIF
__ENDIF_15                                                  


                  cmps          character,#$0A WZ, WC        '    IF character = $0A THEN     ' Set Column (X) Position
    IF_NE         jmp           #__ELSE_17                  

                  mov           Flag,character               '      Flag = character          ' Sets the Flag to the passed variable

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_17                                                    '    ENDIF
__ENDIF_17                                                  


                  cmps          character,#$0B WZ, WC        '    IF character = $0B THEN     ' Set Row (Y) Position
    IF_NE         jmp           #__ELSE_18                  

                  mov           Flag,character               '      Flag = character          ' Sets the Flag to the passed variable

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_18                                                    '    ENDIF
__ENDIF_18                                                  


                  cmps          character,#$0C WZ, WC        '    IF character = $0C THEN     ' Set current Colour
    IF_NE         jmp           #__ELSE_19                  

                  mov           Flag,character               '      Flag = character          ' Sets the Flag to the passed variable

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_19                                                    '    ENDIF
__ENDIF_19                                                  


                  cmps          character,#$0D WZ, WC        '    IF character = $0D THEN     ' Carriage Return
    IF_NE         jmp           #__ELSE_20                  

                  call          #NEWLINE                     '      NEWLINE

                  jmp           #EXIT_SUB                    '      GOTO EXIT_SUB

__ELSE_20                                                    '    ENDIF
__ENDIF_20                                                  


                  mov           __param1,character           '    PRINT character             ' Print the vale passed
                  call          #PRINT                      


__ELSE_11                                                    '  ENDIF
__ENDIF_11                                                  


                  cmps          Flag,#$0A WZ, WC             '  IF Flag = $0A THEN            ' Set Column (X) Position
    IF_NE         jmp           #__ELSE_21                  
__IF_21                                                     

                  mov           Col,character                '    col = character

                  mov           Flag,#0                      '    Flag = 0

                  jmp           #EXIT_SUB                    '    Goto EXIT_SUB

__ELSE_21                                                    '  Endif
__ENDIF_21                                                  



                  cmps          Flag,#$0B WZ, WC             '  IF Flag = $0B THEN            ' Set Row (Y) Position
    IF_NE         jmp           #__ELSE_22                  
__IF_22                                                     

                  mov           Row,character                '    row = character

                  mov           Flag,#0                      '    Flag = 0

                  jmp           #EXIT_SUB                    '    Goto EXIT_SUB

__ELSE_22                                                    '  Endif
__ENDIF_22                                                  


                  cmps          Flag,#$0C WZ, WC             '  IF Flag = $0C THEN            ' Set current Colour
    IF_NE         jmp           #__ELSE_23                  
__IF_23                                                     

                  mov           Colour,character             '    colour = character & 7
                  and           Colour,#7                   

                  mov           Flag,#0                      '    Flag = 0

__ELSE_23                                                    '  Endif
__ENDIF_23                                                  


EXIT_SUB                                                     '  EXIT_SUB:


Out_ret                                                      'ENDSUB
                  ret                                       
                                                            

                                                             ''{$ENDIF}
                                                             ''========================================================================================


                                                             ''PUB inkblock(x,y,w,h,pen) | x1,y1
                                                             ''  repeat y1 from y to y+h-1
                                                             ''    repeat x1 from x to x+w-1
                                                             ''      screen[y1*cols+x1]:=screen[y1*cols+x1]&$7ff + ((pen&7)<<11)
                                                             ''{$CODE}

                                                             ''{$ENDIF}


                                                             ''{$ENDIF}

                                                             ''{$ENDIF}

                                                             '' ----------------------------------------------------------------------
                                                             '' TASK
                                                             '' ----------------------------------------------------------------------

                                                             ''{$TASKS}

                                                             '' ======================================================================

'**********************************************************************
__InitDirA       LONG %00000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
_hex80000000     LONG $8000_0000
_minus1          LONG -1
_hex200          LONG $200
_hex220          LONG $220
__colours_ofs    LONG colours_ofs
_FREQ            LONG 80000000
_1000000000      LONG 1_000_000_000

TV_curX          LONG 0
TV_curY          LONG 0
Colour           LONG 0
Col              LONG 0
Row              LONG 0
Flag             LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
Char
dcDigit
hxDigit
biDigit
character
__param1         RES 1
dcVal
hxVal
biVal
__param2         RES 1
dcDiv
hxCount
biCount
__param3         RES 1
dcNegX
__param4         RES 1
__paramcnt       RES 1
TempVar1         RES 1
TempVar2         RES 1
TempVar3         RES 1
__TempVar1       RES 1
__TempVar2       RES 1
__TempVar3       RES 1
__TempVar4       RES 1
__TempVar5       RES 1
__TempVar6       RES 1
__TempVar7       RES 1
LastRow          RES 1
ScrOffset        RES 1
ScrPointer       RES 1
ScreenRAM        RES 1
ScreenColours    RES 1
srcptr           RES 1
dstptr           RES 1
Fore             RES 1
Back             RES 1
dcPrint          RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  TV_PARALLAX_COG_ofs              = 0
  InLineStr1_ofs                   = 4
  InLineStr2_ofs                   = 42
  InLineStr3_ofs                   = 75
  cols                             = 40
  rows                             = 13
  TV_PARAMS_ofs                    = 108
  SCRPTR_ofs                       = 124
  COLPTR_ofs                       = 128
  PALETTE_ofs                      = 164
  scrbuf_ofs                       = 180
  colours_ofs                      = 1220

' TASK TV_PARALLAX                                           'TASK TV_PARALLAX


                                                             '' ----------------------------------------------------------------------
                                                             '' SUB/FUNC Code
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------


                                                             '' ======================================================================
                                                             '' TASK Code
                                                             '' ======================================================================


DAT
__DATASTART
TV_PARALLAX_COG  LONG 0
InLineStr1
                 BYTE "   TV Text Demo...  PropBASIC Version",0
InLineStr2
                 BYTE " OBJ and VAR require only 2.8KB ",0
InLineStr3
                 BYTE "     Uses internal ROM font     ",0
TV_PARAMS
                 LONG 0
                 LONG 1
                 LONG 21
                 LONG 19
SCRPTR
                 LONG 0
COLPTR
                 LONG 0
                 LONG cols
                 LONG rows
                 LONG 5
                 LONG 1
                 LONG 0
                 LONG 0
                 LONG 0
                 LONG 0
PALETTE
                 BYTE $07,$0A
                 BYTE $07,$BB
                 BYTE $9E,$9B
                 BYTE $04,$07
                 BYTE $3D,$3B
                 BYTE $6B,$6E
                 BYTE $BB,$CE
                 BYTE $3C,$0A
scrbuf           WORD 544[520]
colours          LONG 0[16]


